.386 
.model flat,stdcall 
option casemap:none 
WinMain proto :DWORD,:DWORD,:DWORD,:DWORD 

include \masm32\include\windows.inc 
include \masm32\include\user32.inc 
include \masm32\include\kernel32.inc 
include \masm32\include\gdi32.inc

includelib \masm32\lib\user32.lib 
includelib \masm32\lib\kernel32.lib 
includelib \masm32\lib\gdi32.lib

.data 
ClassName db "WinClass",0 
AppName db "scroll",0 

.data? 
hInstance HINSTANCE ? 
CommandLine LPSTR ? 
hBitmap dd ?

.code 
start: 
invoke GetModuleHandle, NULL 
mov hInstance,eax 
invoke GetCommandLine
mov CommandLine,eax 
invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT 
invoke ExitProcess,eax 
; 

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD 
LOCAL wc:WNDCLASSEX 
LOCAL msg:MSG 
LOCAL hwnd:HWND 
mov wc.cbSize,SIZEOF WNDCLASSEX 
mov wc.style, CS_HREDRAW or CS_VREDRAW 
mov wc.lpfnWndProc, OFFSET WndProc 
mov wc.cbClsExtra,NULL 
mov wc.cbWndExtra,NULL 
push hInst 
pop wc.hInstance 
mov wc.hbrBackground,COLOR_BTNFACE+1 
mov wc.lpszMenuName, 0h 
mov wc.lpszClassName,OFFSET ClassName 
invoke LoadIcon,NULL,IDI_APPLICATION 
mov wc.hIcon,eax 
mov wc.hIconSm,eax 
invoke LoadCursor,NULL,IDC_ARROW 
mov wc.hCursor,eax 
invoke RegisterClassEx, addr wc 
invoke CreateWindowEx,WS_EX_CLIENTEDGE,ADDR ClassName, \ 
ADDR AppName, WS_OVERLAPPEDWINDOW or WS_VSCROLL or WS_CLIPCHILDREN,\ 
CW_USEDEFAULT, CW_USEDEFAULT,\ 
185,200,NULL,NULL, hInst,NULL
mov hwnd,eax 
invoke ShowWindow, hwnd,SW_SHOWNORMAL 
invoke UpdateWindow, hwnd 
.WHILE TRUE 
invoke GetMessage, ADDR msg,NULL,0,0 
.BREAK .IF (!eax)
invoke TranslateMessage, ADDR msg 
invoke DispatchMessage, ADDR msg 
.ENDW 
mov eax,msg.wParam 
ret 
WinMain endp 
; 

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM 

  LOCAL ps      :PAINTSTRUCT 
  LOCAL hdc     :HDC 
  LOCAL hMemDC  :HDC 
  LOCAL rect    :RECT 
  LOCAL sci     :SCROLLINFO
  LOCAL bmp     :BITMAP
  LOCAL yNewPos :DWORD

      .IF uMsg==WM_DESTROY 
                invoke DeleteObject,hBitmap
                invoke PostQuitMessage,NULL 
      
      .elseif uMsg==WM_CREATE
                invoke LoadBitmap,hInstance,700 
                mov hBitmap,eax 
                ; // Retrieve the metrics for the bitmap
                invoke GetObject, hBitmap,sizeof BITMAP,addr bmp
      
      .elseif uMsg==WM_PAINT 
                invoke BeginPaint,hWnd,addr ps 
                mov hdc,eax 
                invoke CreateCompatibleDC,hdc 
                mov hMemDC,eax 
                invoke SelectObject,hMemDC,hBitmap 
                invoke GetClientRect,hWnd,addr rect 
                invoke BitBlt,hdc,0,0,rect.right,rect.bottom,hMemDC,0,0,SRCCOPY 
                invoke DeleteDC,hMemDC 
                invoke EndPaint,hWnd,addr ps 
; 

     .elseif uMsg==WM_SIZE
      
         ;     si.nPage = HIWORD(lParam)
         mov ecx, lParam
         and ecx, 0ffffh
 
 ;         // The vertical scrolling range is defined by 
 ;         // (bitmap_height) - (client_height). The current vertical 
 ;         // scroll value remains within the vertical scrolling range. 
 ;         // We need to bring back the yNew size to the scroll bar messages above
 
 ;         yMaxScroll = max(bmp.bmHeight - yNewSize, 0); 

            mov eax, bmp.bmHeight
            sub eax, ecx
            cmp eax, 0
            jb @f
            mov sci.nMax, eax
            @@:

 ;         yCurrentScroll = min(yCurrentScroll, yMaxScroll); 

            mov eax, sci.nMax
            sub ecx, sci.nPos
            cmp eax, ecx
            ja @f
            mov sci.nPos, eax
            @@:
            
           invoke SetScrollInfo, hWnd, SB_VERT, addr sci, TRUE

 ;  si.cbSize = sizeof(si)
 ;  si.fMask  = SIF_RANGE | SIF_PAGE | SIF_POS
 ;  si.nMin   = yMinScroll
 ;  si.nMax   = yMaxScroll
 ;  si.nPage  = yNewSize
 ;  si.nPos   = yCurrentScroll

; 


   .elseif uMsg==WM_VSCROLL
   
     mov eax, wParam
   
            .if ax == SB_PAGEUP              ;// User clicked the scroll bar shaft above the scroll box. 
                   mov eax, sci.nPos
                   sub eax, 50
                   mov yNewPos, eax
     
            .elseif ax == SB_PAGEDOWN         ;// User clicked the scroll bar shaft below the scroll box. 
                   mov eax, sci.nPos
                   add eax, 50
                   mov yNewPos, eax

            .elseif ax == SB_LINEUP           ;// User clicked the top arrow. 
                   mov eax, sci.nPos
                   sub eax, 5
                   mov yNewPos, eax

            .elseif ax == SB_LINEDOWN         ;// User clicked the bottom arrow. 
                   mov eax, sci.nPos
                   add eax, 5
                      mov yNewPos, eax
     
            .elseif ax == SB_THUMBPOSITION   ;// User dragged the scroll box. 

                    mov eax, wParam
                    and eax, 0ffffh
                    mov yNewPos, eax

  invoke SetScrollPos, hWnd, SB_VERT, yNewPos,TRUE

  
 ;         ScrollWindowEx(hwnd, -xDelta, -yDelta, (CONST RECT *) NULL, 
 ;             (CONST RECT *) NULL, (HRGN) NULL, (LPRECT) NULL, 
 ;             SW_INVALIDATE); 
 ;         UpdateWindow(hwnd); 

;   invoke ScrollWindowEx, hWnd, 0, -yDelta, sci, addr rect, addr rect, SW_INVALIDATE
invoke UpdateWindow, hWnd
 .endif
; 

  .ELSE 
  invoke DefWindowProc,hWnd,uMsg,wParam,lParam 
  ret 
  .ENDIF 
  xor eax,eax 
  ret 
  WndProc endp 
; 

end start 
